<template>
  <q-page class="q-pa-lg">

    <q-btn :to="{ name: 'time', params: { idCommunity: idCommunity, idTime: idTime } }" flat class="q-pa-none">
      <q-icon name="arrow_back" size="sm" />
    </q-btn>

    <h1>{{ room.label }}</h1>

    <div class="row justify-between">
      <div class="">
        <p class="text-subtitle1 q-mb-none">
          
          <q-popup-edit
            v-model.number="manualCounter"
            @save="saveManualCounter"
            auto-save
            square
            anchor="top left"
            v-slot="scope"
          >
            <q-input v-model.number="scope.value" type="number" dense autofocus @keyup.enter="scope.set" :rules="[ val => (val >= 0 && val !== '') || 'Mmm, seriously?' ]">
              <template v-slot:prepend>
                <q-icon name="people" color="primary" />
              </template>
            </q-input>
          </q-popup-edit>

          {{ room.counter }} / 
          <span v-if="room.quota == '-1'"> ∞</span>
          <span v-else>{{ room.quota }}</span>
        </p>
      </div>
      <div class="" v-if="room.quota != '-1'">
        <p class="text-subtitle1 q-mb-none">{{ Math.round(progress * 100) }}%</p>
      </div>
    </div>
    
    <q-linear-progress v-if="room.quota != '-1'" :value="progress" :color="getColor(room)" stripe rounded size="xl" class="q-mb-md" />
    
    <div class="row q-gutter-y-md">
      <q-btn
        @click="add()"
        outline
        label="+"
        color="green-5"
        class="full-width bg-green-1"
        style="font-size: 100px;"
      />
      <q-btn
        :disable="room.counter <= 0"
        @click="remove()"
        outline
        label="–"
        color="red-5"
        class="full-width bg-red-1"
        style="font-size: 40px;"
      />
    </div>

  </q-page>
</template>

<script>
import { defineComponent, ref } from "vue";
import { mapGetters } from "vuex";
import { getDatabase, ref as refFb, set, update, onValue } from "firebase/database";

export default defineComponent({
  name: "PageRoom",
  props: {
    idCommunity: {
      required: true,
    },
    idTime: {
      required: true,
    },
    idRoom: {
      required: true,
    },
  },
  setup() {

    const db = getDatabase();
    let room = ref([]);
    let manualCounter = ref();

    return {
      db,
      room,
      manualCounter
    };
  },
  computed: {
    ...mapGetters({
      user: "counter/getUser",
      isAdmin: "counter/isAdmin",
    }),
    progress() {
      return this.room.counter / this.room.quota;
    }
  },
  mounted() {
    this.loadRoom(this.idCommunity, this.idTime, this.idRoom);
  },
  async beforeRouteUpdate(to, from) {
    this.loadRoom(to.params.idCommunity, to.params.idTime, to.params.idRoom);
  },
  watch: {
    "room.counter"(newVal, oldVal) {
      this.manualCounter = newVal;
    },
  },
  methods: {
    saveManualCounter(newValue, initialValue) {
      if (newValue < 0 || newValue === '') {
        this.manualCounter = initialValue;
      } else {
        this.room.counter = newValue;
        this.updateCounter(newValue);
      }
    },
    add() {
      let newValue = this.room.counter + 1;
      this.updateCounter(newValue);
    },
    remove() {
      let newValue = this.room.counter - 1;
      this.updateCounter(newValue);
    },
    updateCounter(newValue) {
      const updates = {};
      updates["communities/" + this.idCommunity + "/times/" + this.idTime + "/rooms/" + this.idRoom + '/counter'] = newValue;
      update(refFb(this.db), updates);
    },
    loadRoom(idCommunity, idTime, idRoom) {

      const db = getDatabase();
      var roomRef = refFb(db, "communities/"+ idCommunity +"/times/" + idTime + "/rooms/" + idRoom);

      onValue(roomRef, (snapshot) => {
        const data = snapshot.val();
        this.room = data;
      });
    },
    getColor(room) {
      var progress = this.progress * 100;
      if (progress < 85) return 'green';
      if (progress < 100) return 'orange';
      return 'red';
    },
  },
});
</script>
